\documentclass[a4paper,10pt]{article}

\begin{document}

\title{\textbf{System Initialization}}
\author{Pawel Dziepak}
\date{\textit{July 16, 2008}}
\maketitle

\section{Bootloader}
\paragraph{}Quarn OS uses its own bootloader to boot and prepare CPU and whole computer to
execute kernel's code. There is a different version of bootloader code for each
architecture, becasue it is written in assembler language, so it is platform
dependent. There is also posibillity to choose a file system that system loader
will be read from, but the certain reading procedures have to be included at
compilation. Bootloader can not be larger than 512 bytes, so everything has to
be size-optimized.
\paragraph{}Optionally Quarn OS can use GRUB or other bootloaders to boot. Then another
version of system loader is used (more information in the next point), which
will create the same enivronment of execution (as after booting using Quarn's
bootloader) before running kernel.
\paragraph{}The exact operations done by bootloader depends on the platform it is
designed for. More information can be found in the source code and docs
for the certain architecture.

\section{System loader}
\paragraph{}When using the standard Quarn OS bootloader, system loader is treated as a
second stage. Its task is to prepare CPU (and other parts of hardware) to run
the kernel. System loader also loads the executable file which consist of Quarn
and prepares it to execute (if it is needed by the format of the file).
\paragraph{}If external bootloader is used, system loader provides a needed interface for
it (for example, if using GRUB, system loader implements all parts of Muliboot
Specification needed). Then, if it is necessary system loader prepares the 
computer to execute the kernel.
\paragraph{}The exact operations done by system loader depends on the platform it is
designed for. More information can be found in the source code and docs
for the certain architecture.

\section{Initializing kernel (low-level)}
\paragraph{}When boots, first thing that kernel does is to prepare system to executed code
written in the C++ programming language. It means that kernel calls constructors
of all static and global objects.
\paragraph{}Then kernel launches Managed Execution System Initializer. It creates and initiliazes
the main manager of Manes. Then the manager is connected to the Managed Execution System
Controller (Manec) instance that is used by core Quarn OS code. From now Manes is ready to work.

\section{Initializing kernel (high-level)}
\paragraph{}When kernel is prepared to operate Manec procedure registers main creators types,
built-in objects types. Then all controllers are created and initialized (animated). This operation
includes scaning buses for devices, loading file system metadata, connecting to remote Manes
servers, creating task switch segments. More information about animating a specific creator can be
found in its documentation.
\paragraph{}The final step is to load module from file ``start.ko'' and execute it using an actors
system. The module should launch shell or login prompt and allow user to communicate with the system.

\end{document}
